
#include <stdio.h>
#include <snmp.h>



void fatal()
{
	printf("\nError : %s\n\n",snmpError);
	exit(1);
}

void main(argc,argv)
	int	argc;
	char	*argv[];
{
	char	*host, *community;
	snmpvar	objects[24];
	snmp	*session;
	int	count,
		numVars;

	if (argc < 4)
	{
		printf("\nusage : snmpgetnext host community var ....\n\n");
		exit(1);
	}

	if (snmpInit() < 0)
		fatal();


	host = argv[1];
	community = argv[2];

	count = 3;
	numVars = 0;
	while(count < argc)
	{
		if (snmpCheckVariable(argv[count]) < 0)
			fatal();
		snmpAddVariable(argv[count], &objects[numVars]);
		numVars++;
		count++;
	}

	session = snmpOpen(host,community,SNMP_DEF_TIMEOUT,SNMP_DEF_RETRIES);
	if (!session)
		fatal();

	if (snmpGetNext(session,objects, numVars) < 0)
		fatal();

	count = 0;
	while(count < numVars)
	{
		printf("%s  =  %s\n", objects[count].textID,
			objects[count].textVal);
		count++;
	}
	exit(0);
}
