/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <errno.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <stdio.h>
#include <stdlib.h>

#include "common.h"
#include "snmp.h"

int UdpOpen(hname)
	char	*hname;
{
	struct hostent *ent;
	struct sockaddr_in server;
	int s;
	unsigned long adr;
	int ret;
	char name[512], *pptr;
	int ptr, pnr;

	/* try to split the hostname in two parts dutepp2.et.tudelft.nl:172 */
	pptr = NULL;
	for (ptr = 0; hname[ptr] != '\0'; ptr++)
	{
		if (hname[ptr] == ':')
		{
			name[ptr] = '\0';
			pptr = hname + ptr + 1;
			break;
		}
		else
		{
			name[ptr] = hname[ptr];
		}
	}
	name[ptr] = '\0';

	adr = inet_addr(name);
	if (adr == -1)
	{
		ent = gethostbyname(name);
		if (ent == NULL)
		{
			sprintf(snmpError,"can't resolve hostname '%s'",name);
			return (-1);
		}
		adr = ((struct in_addr *) (ent->h_addr))->s_addr;
	}
	if (pptr != NULL)
		pnr = atoi(pptr);
	else
	{
		pnr = SNMP_PORT;
	}

	s = socket(AF_INET, SOCK_DGRAM, 0);
	if (s < 0)
        {
		sprintf(snmpError,"cant get udp socket");
		return (-1);
        }
	server.sin_family = AF_INET;
	server.sin_port = htons(pnr);
	server.sin_addr.s_addr = adr;

	if (connect(s, (struct sockaddr *) &server, sizeof(server)) != 0)
	{
		sprintf(snmpError, "error in udp connect to '%s'",name);
		close(s);
		return (-1);
	}
	return s;
}



int UdpSend(sock, buffer, length)
	int	sock; 
	char 	* buffer; 
	unsigned length;
{
	int s, ret;

	ret = send(sock, buffer, length, 0);
	return (ret);
}


int UdpRecv(sock, buffer, length, timeout)
	int	sock; 
	char 	** buffer; 
	unsigned *length; 
	unsigned long timeout;
{
	int  ret;
	fd_set mask;
	struct timeval t;
	static char data[BUF_LEN];

	t.tv_sec = timeout / 1000000L;
	t.tv_usec = timeout % 1000000L;

	ret = -1;
	FD_ZERO(&mask);
	FD_SET(sock, &mask);
	ret = select(sock + 1, &mask, NULL, NULL, &t);

	if (ret > 0)
	{
		/* socket has been released */
		ret = recv(sock, data, sizeof(data), 0);
		if (ret >= 0)
		{
			*buffer = data;
			*length = ret;
		}
	}
	return (ret);
}
