/*
**	mod_snmp.h	- Lite / W3-mSQL module for SNMP
**
**
** Copyright (c) 1997  Hughes Technologies Pty Ltd.
**
** Permission to use, copy, and distribute for non-commercial purposes,
** is hereby granted without fee, providing that the above copyright
** notice appear in all copies and that both the copyright notice and this
** permission notice appear in supporting documentation.
**
** The software may be modified for your own purposes, but modified versions
** may not be distributed.
**
** This software is provided "as is" without any expressed or implied warranty.
**
*/




/*
** SNMP external function prototypes
*/

void doSnmpOpen();
void doSnmpClose();
void doSnmpGet();



/*
** Note : Dynamic loaded modules do not need to provide function
** pointers as the addresses of the module interface functions will
** be determined as it is loaded at run-time
*/

/*
** SNMP external function definitions
**
** This table maps from internal Lite function names to the C code.
** The format is :-
**
**	{LiteName, CFunctPtr, CFuntName, NumArgs, { Arg1Type, Arg2Type..., 0}}
**
**	Setting NumArgs to -1 indicates varargs
*/


efunct_t snmp_efuncts[] = {
	{ "snmpopen", NULL, "_doSnmpOpen", 2, {P_TEXT, P_TEXT, 0} },
	{ "snmpclose", NULL, "_doSnmpClose", 1, {P_INT,  0} },
	{ "snmpget", NULL, "_doSnmpGet", 2, {P_INT, P_ARRAY, 0} },
	{ "snmpgetnext", NULL, "_doSnmpGetNext", 2, {P_INT, P_ARRAY, 0} },

	{ NULL, 0 }
};
